/************************************************************************************/
/***** f[^͂̂߂SAS@***************************************************/
/***** o[W: QŁ@@**********************************************************/
/***** 쐬F {x, gV֎q  ***************************************************
/***** t:  2014/02/07 ************************************************************/
/************************************************************************************/

/***** 4́@W {  z    ********************************************************/

/*****   4.1@W{ς̕W{z   ***************************************************/

goptions reset=all;
title;

title1   'Dist. of Sample means of Random Samples';
title2   'from Standard Normal Distributions';
title3   'of size 4 and 10000 iterations';

data ex411;
 it = 10000;  size = 4;
 do i = 1 to it;
  sumz = 0;
   do j = 1  to  size; 
    z = rannor(0);
    sumz = sumz + z;
   end;
  xbar = sumz/size;
  output;
 end;
run;
proc  means  data=ex411  vardef=n ;
  var  xbar ;
run;
proc  univariate  data=ex411  noprint;
 histogram  xbar / normal;
 qqplot  xbar;
run;

title1   'Dist. of Sample means of Random Samples';
title2   'from Standard Normal Distributions';
title3   'of size 4 and 10000 iterations';
proc sgplot data=ex411;
 histogram  xbar ;
 density  xbar ;
 run; 

data ex411a;
 it = 10000;  size = 4;
 do i = 1 to it;
   do j = 1 to size; 
    z = rannor(0);
  output;
  end;
 end;
run;

proc  means  data=ex411a  mean  noprint;
  var z;
  by i;
  output  out=outmean  mean=xb;
run;
proc  means  data=outmean  vardef=n;
var  xb;
run;

title   'Dist. of Random Samples';
title2  'Standard Normal Distributions';
title3  'of size 4';
data ex411b;
 size = 4;
  do i = 1 to size;
   z = rannor(0);
   output;
  end;
run;

proc  means  data=ex411b  vardef=n ;
 var z;
run;
proc  gchart  data=ex411b;
 hbar z /
 maxis=axis1  axis=axis1  space=0;
 axis1  label=(h=1.5)  value=(h=1.5) ; 
run;

title    'Dist. of Sample means of Random Samples';
title2   'from(0,1) Uniform Distributions';
title3   'of size 4 and 10000 iterations';

data ex412;
 it = 10000;  size = 4;
 do i = 1 to it;
  sumz = 0;
   do j = 1 to size;
    z = ranuni(0);
    sumz = sumz+z;
   end;
  xbar = sumz/size;
  output;
 end;
run;

proc  means  data=ex412  vardef=n;
 var  xbar ;
run;
proc  univariate  data=ex412  noprint;
 histogram  xbar / normal;
 qqplot xbar;
run;
quit;

title   'Dist. of Sample means of Random Samples';
title2  'from Exponential with m=1';
title3  'of size 4 and 10000 iterations';

data ex413;
it = 10000; size = 4;
 do i = 1 to it;
  sumz = 0;
   do j = 1 to size;
     z = ranexp(0);
     sumz = sumz+z;
   end;
  xbar = sumz/size;
 output;
 end;
run;

proc means data=ex413  vardef=n;
 var xbar;
run;
proc  univariate  data=ex413 noprint;
 histogram  xbar/normal;
 qqplot  xbar;
run;

title   ' Dist. of Sample means of Random Samples';
title2  'from Bernoulli Distributions with p=0.8';
title3  'of size 4 and 10000 iterations';

data ex414;
it = 10000; size = 4;
 do i = 1 to it;
 sumz = 0;
  do j = 1 to size;
   z = ranbin(0,1,0.8);
   sumz = sumz+z;
   end;
  xbar = sumz/size;
  output;
 end;
run;
proc  means  data=ex414  vardef=n ;
 var xbar ;
run;
proc  gchart  data=ex414 ;
 hbar  xbar/nostat  discrete ;
run;

title;

data ex415;
it = 100; size = 10;
 do i = 1 to it;
 sumz = 0;
  do j = 1 to size;
   z = ranbin(0, 1, 0.5);
   sumz = sumz+z;
   end;
  xbar = sumz/size;
  output;
 end;
run;

/*** 4.1.5@吔̖@ **************************************/
goptions reset=all;
title;

title   'RC̕\o銄';
title2  '100lRCꂼ10񓊂';
proc  gplot  data=ex415;
plot  xbar*i /
  vaxis=axis1  haxis=axis2
  vref = 0.5  cvref = red 
;
symbol  i=join v=none ;
axis1  order=(0 to 1 by 0.2);
axis2  label=('RC100l') ; 
run; quit;

title   'RC̕\o銄';
title2  '100lRCꂼ10񓊂';
proc  sgplot data=ex415;
 series x=i y=xbar;
 refline 0.5 / lineattrs=(color=red) ; 
 run; 

goptions reset=all; 

data ex416;
 size = 500; sumz = 0;
  do j = 1 to size;
   z = ranbin(0, 1, 0.5);
   sumz = sumz+z;
   xbar = sumz/j;
  output;
  end;
run;
title  'RC̕\o銄';
proc  gplot  data=ex416;
plot  xbar*j / vaxis=axis1  haxis=axis2  vref=0.5  cvref=red;
symbol  i=join  v=none ;
axis1  order =(0 to 1 by 0.2)  ;
axis2  label =('RC') ; 
run; quit;

/*** 4.1.6@SɌ藝 *****************************************/
goptions reset=all;
title;

title    'Dist. of Sample means of Random Samples';
title2   'from Bernoulli Distributions with p=0.8';
title3   'of size 400 and 25000 iterations';

data ex417;
it = 25000;  size = 400;
 do i = 1 to it;
 sumz = 0;
  do j = 1 to size;
   z = ranbin(0, 1, 0.8);
   sumz = sumz+z;
   end;
  xbar = sumz/size;
  output;
 end;
run;

proc  means  data=ex417;
 var  xbar;
run;
proc  univariate  data=ex417  noprint;
 histogram  xbar/normal;
 qqplot  xbar;
run;

/**** 4.2@W{U̕W{z  **************************************/
goptions reset=all;
title;

title    'Dist. of Sample variance of Random Samples';
title2   'from Standard Normal Distributions';
title3   'of size 4 and 10000 iterations';

data ex421;
it = 10000; size = 4;
 do i = 1 to it;
  sumz = 0 ; sumz2 = 0;
   do j = 1 to size; 
    z = rannor(0);
    sumz = sumz+z ;
    sumz2 = sumz2+z**2 ;
   end;
  xbar = sumz/size;
  xdev = sumz2-(sumz)**2/size;
  svar = xdev/size;
  uvar = xdev/(size-1);
  output;
 end;
run;

proc  means  data=ex421  vardef=n;
 var  svar  uvar;
run;
proc  univariate  data=ex421  noprint;
 histogram  xdev / gamma(alpha=1.5, scale=2);
 qqplot  xdev / gamma(alpha=1.5, scale=2);
run;

title     'Dist. of Sample variance of Random Samples';
title2    'from(0,1) Uniform Distributions';
title3   'of size 4 and 10000 iterations';

data ex422;
 it = 10000;  size = 4;
 do i = 1 to it;
  sumz = 0 ;  sumz2 = 0;
   do j = 1 to size; 
     z = ranuni(0);
     sumz = sumz+z;
     sumz2 = sumz2+z**2;
   end;
  xbar = sumz/size;
  xdev = sumz2-(sumz)**2/size;
  svar = xdev/size;
  uvar = xdev/(size-1);
  vdev = 12*xdev;
  output;
 end;
run;

proc  means  data=ex422  vardef=n;
 var svar uvar;
run;
proc  univariate  data=ex422  noprint;
 histogram vdev / gamma(alpha=1.5, scale=2);
 qqplot vdev / gamma(alpha=1.5, scale=2);
run;

title    'Dist. of Sample variance of Random Samples';
title2   'from Exponential Distributions with m=1';
title3   'of size 4 and 10000 iterations';

data ex423;
 it = 10000; size = 4;
 do i = 1 to it;
  sumz = 0 ; sumz2 = 0;
   do j = 1 to size; 
     z = ranexp(0);
     sumz = sumz+z;
     sumz2 = sumz2+z**2;
   end;
  xbar = sumz/size;
  xdev = sumz2-(sumz)**2/size;
  svar = xdev/size;
  uvar = xdev/(size-1);
  output;
 end;
run;

proc  means  data=ex423  vardef=n;
 var  svar uvar;
run;
proc  univariate  data=ex423  noprint;
 histogram  xdev / gamma(alpha=1.5, scale=2);
 qqplot  xdev / gamma(alpha=1.5, scale=2);
run;


/*** 4́EK  *********************************************/
goptions reset=all;
title;

data nd;
it = 10000; n = 10; m = 10;
do j = 1 to it;
  sumx = 0;
  do i = 1 to n;
    x = rannor(0);
    sumx = sumx+x;
  end;
  xbar = sumx/n;
  sumy = 0;
  do i = 1 to m;
    y = 3+rannor(0);
    sumy = sumy+y;
  end;
ybar = sumy/m;
  diff = xbar-ybar;
  output;
end;
proc  means  data=nd mean std min max;
  var diff; run;
proc univariate  data=nd noprint;
  histogram  diff / normal;
  qqplot  diff ;
run;
quit;

title   'Dist. of t statistics of Random Samples';
title2  'from Normal Distributions with mean 1 and sd 1';
title3  'of size 8 and 10000 iterations';
data ext45;
it = 10000; size = 8; mu = 1; sigma = 1;
 do i = 1 to it;
  sumz = 0 ; sumz2 = 0;
   do j = 1 to size; 
    z = mu+sigma*rannor(0);
    sumz = sumz+z;
    sumz2 = sumz2+z**2;
   end;
  xbar = sumz/size;
  xdev = sumz2-(sumz)**2/size;
  svar = xdev/size;
  uvar = xdev/(size-1);
  t = sqrt(size)*(xbar-mu)/sqrt(uvar);
  output;
 end;
run;

proc  sort  data=ext45;
  by t;  run;
proc  univariate  noprint  data= ext45;
var t;
output  out=qqdata  n=nobs  mean=mean std=std;
data qq ;
set ext45;
kk+1; df = size-1;
p = (kk-.375)/(it+0.25);
z = quantile('t',p,df);
label z ='t Quantile';
proc gplot  data = qq;
title 't Q-Q plot';
plot t*z = 1;
symbol  i=none  v=dot  h=0.5  color=black;
run;
quit;

data;
do x = 0 to 6 by 0.01;
  y = pdf('weibull',x,1.5,2);
  output;
end;
title 'Weibull distribution';
proc  gplot;
plot  y*x;
symbol i=join  v=none;
run;
quit;

title  'Dist. of Sample means of Random Samples';
title2 'from Weibull Distributions with 1.5, 2';
title3 'of size 9 and 10000 iterations';
data ex46;
 it = 10000;  size = 9;
 do k = 1 to it;
   do j = 1 to size; 
    t = rand('weibull',1.5,2);
  output;
  end;
 end;
run;
proc  means  data=ex46  mean  noprint  nway;
  var t;
  class k;
  output  out=outmean  mean=xb;
run;
proc  means  data=outmean  vardef=n;
var xb;
run;
proc univariate  data=outmean  noprint;
 histogram  xb / normal(mu=est sigma=est);
 qqplot xb / normal(mu=est sigma=est);
run;

