/************************************************************************************/
/***** f[^͂̂߂SAS@***************************************************/
/***** o[W: QŁ@@**********************************************************/
/***** 쐬F {x, gV֎q  ***************************************************/
/***** t:  2014/02/07 @**********************************************************/
/************************************************************************************/

/****  6 䗦̐ *************************************************************/

/****  6.1@Wc̔䗦̐ ******************************************************/

goptions reset=all;
title;

data ex611;
input  id vote $ ;
if vote = 'y' then  nvote= 1;
if vote = 'n' then  nvote= 0;
cards;
1 y 
2 y
3 n 
4 n 
5 n
6 y
7 y 
8 y
9 n
10 y
11 y 
12 n
13 n
14 y 
15 y 
16 y 
;
proc  freq  data=ex611 ;
table  vote / binomial  (p=0.7  level="y") alpha=.01;
exact  binomial;
run;

proc freq data=ex611 ;
table  vote / binomialc(p=0.7 level="y") alpha=.01;
run;

data ex612;
input r $ count;
datalines;
y 34
n 66
;
proc freq  data=ex612;
weight count;
table r / binomialc (p=0.3 level="y") ;
exact  binomial;
run;

data b6ci;
p = 0.3;  n = 10;
do j = 1 to 20000;
 do i = 1 to n;
  x = ranbin(0,1,p);
  x = 1- x;
   output;
 end;
end;
run;
proc freq  data=b6ci  noprint ;
by j;
tables  x / binomial;
output  out=t1  bin;
run;
data t2;
set t1 ;  set b6ci(keep=p);
if l_bin > p or u_bin< p  then cover=0;
else  cover=1;
if xl_bin > p  or  xu_bin< p  then xcover=0;
else  xcover=1;
proc means  data=t2 n sum mean;
var  cover  xcover;
run;

data b6t;
p = 0.3; n = 10;
do j = 1 to 20000;
 do i = 1 to n;
  x = 1-ranbin(0,1,p);
   output;
 end;
end;
proc freq  data=b6t noprint ;
by j;
tables  x / binomial(p=0.3);
exact binomial;
output out=t1 bin;
run;
data t2;
a = .05;
set t1 ;
if  p2_bin > a  then  sig=0;
else  sig=1;
if  xp2_bin > a  then  xsig=0;
else  xsig=1;
proc means  data=t2 n sum mean;
var sig  xsig;
run;

data b6t;
p = 0.5; n = 50;
do j = 1 to 20000;
 do i = 1 to n;
  x = 1-ranbin(0,1,p);
  output;
 end;
end;
run;
proc freq  data=b6t noprint ;
by j;
tables x / binomial(p=0.3);
exact binomial;
output out=t1 bin;
run;
data t2;
a = .05;
set t1 ;
if p2_bin > a  then sig=0;
else  sig=1;
if xp2_bin > a  then xsig=0;
else  xsig=1;
proc means data=t2  n sum mean;
var sig xsig;
run;

proc power; 
 onesamplefreq  test= exact 
    nullproportion = 0.3 
    proportion = 0.5 
    ntotal = 50 
    power = .; 
run;

proc power; 
  onesamplefreq  test = z  
      method = normal
      nullproportion = 0.3 
      proportion = 0.5 
      ntotal = 50 
      power = .; 
run;

proc power; 
      onesamplefreq  test=z  method=normal
        nullproportion = 0.3 
        proportion = 0.5 
        ntotal = . 
        power = 0.9; 
run;

/***** 6.2@2̃O[v̔䗦̔r  ********************************/
goptions reset=all;
title;

proc format;
 value gfmt 1 = 'j'  2='';
run;
data ex621;
length y  $ 6;
do group = 1 to 2;
 do y = '' , 'Ȃ';
 input  count @@;
   output;
  end;
end;
format  group gfmt.;
 cards; 
20 30 10 24
;
proc freq  data=ex621 order =data;
 weight count; 
 table group * y / chisq riskdiff alpha=0.05;
run;

data ex622;
input group $ improve $ count;
datalines;
placebo  yes  43
placebo  no   57
drug    yes  59
drug    no   41
;
proc freq  data=ex622  order=freq;
tables  group*improve /chisq  nopercent  nocol  riskdiff  relrisk;
weight  count;
run;

proc format;
value $ynfmt 'y'='xK'  'n'='xK';
value $sfmt 's'='i'   'n'='i';
run;
data ex623;
input  cancer $ smoking $ count;
format  cancer $ynfmt. smoking $sfmt.;
cards;
n s 32
n n 11
y s 60
y n 3
;
proc freq data=ex623 order=formatted;
 tables cancer * smoking / chisq  relrisk ;
 weight count;
 exact  or;
run;

data ex624;
length group $ 7 improve $ 10;
do center = 1 to 3;
do group = "drug" , "placebo";
do improve = "yes" , "no";
  input count @;
  output;
  end;
end;
end;
datalines;
59 41 43 57
61 39 40 60
51 49 45 55
;
run;
proc freq data= ex624  order=data;
tables  center*group*improve / cmh  nopercent  nocol
                  riskdiff  relrisk;
weight count;
exact  or;
run;

data ex625;
if _n_ <= 4 then age= "young";
if _n_>4 then age= "old";
input drug $ survival $ count @;
datalines;
a died 40
a survived 60
b died 2
b survived 17
a died 16
a survived 3
b died 70
b survived 30
;
proc freq data=ex625;
tables  age*drug*survival / nopercent  nocol  relrisk  cmh;
weight count;
run;
proc freq data=ex625;
tables  drug*survival/ nopercent  nocol  relrisk;
weight count;
run;

/***** 6.3@Ή̂O[v̔䗦̔r *************************/
goptions reset=all;
title;

proc format;
value $ynfmt 'y' = 'ɂ'  'n' = 'ɂȂ';
run;
data ex631;
input id before $ after $;
format  before  after  $ynfmt.;
label  before = '^O'   after = '^';
cards;
01 y y 
02 n y 
03 n y 
04 y y 
05 n n 
06 y y 
07 n n 
08 n y 
09 y y 
10 n n 
11 y n 
12 n n 
13 y y 
14 y y 
15 n y
;
proc freq  data=ex631;
title 'McNemar test';
tables before * after / agree ;
exact mcnem;
run;

proc format;
value $ynfmt 'y' = 'ɂ'  'n' = 'ɂȂ';
run;
data ex632;
input  before $ after $ count;
format  before  after $ynfmt.;
label before= '^O'  after= '^';
cards;
y y 6
y n 1
n y 4
n n 4
;
run;
proc freq data=ex632;
title  'McNemar test';
tables before * after / agree ;
weight count;
run;

/*** 6́EK ********************************************/
goptions reset=all;
title;

proc power; 
      twosamplefreq  test= pchi 
	  alpha= 0.05
         groupproportions = (.15 .35)  
         groupweights = (1 1) 
	 nullproportiondiff = .0 
         ntotal = . 
         power = 0.8; 
   run;

data bin2;
it=5000; p1=0.35; n1=40; p2=0.55; n2=60;
do k = 1 to it;
  do group= 1,2;
   if group= 1 then do n=n1; p=p1; end;
   else if group=2 then do n=n2; p=p2; end;
     do i = 1 to n;
      x= ranbin(0,1,p);
      output;
   end;
 end;
end;
run;
proc freq  data=bin2 noprint;
by k;
tables group*x / chisq  riskdiff;
output out=simout chisq;
run;
data sim1;
a=0.05;
set simout(keep=p_pchi p_ajchi xp2_fish);
if p_pchi<a then sigc=1; else if  p_pchi>=a then sigc=0;
if p_ajchi<a then sigac=1; else if  p_ajchi>=a then sigac=0;
if xp2_fish<a then sigf=1; else if  xp2_fish>=a then sigf=0;
run;
proc means data=sim1 n mean ;
var sigc sigac sigf;
run;





